<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryRef"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="名称" prop="title">
        <el-input
          v-model="queryParams.title"
          placeholder="请输入名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select
          v-model="queryParams.status"
          class="m-2"
          placeholder="请选择状态"
          clearable
          @keyup.enter.native="handleQuery"
        >
          <el-option
            v-for="option in options"
            :key="option.value"
            :label="option.label"
            :value="option.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
    </el-row>

    <el-table v-loading="loading" :data="datatypeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="序号" align="center" prop="dataTypeId" />
      <el-table-column label="名称" align="center" prop="title" />
      <el-table-column label="描述" align="center" prop="description" />
      <el-table-column label="组件" align="center" prop="component" />
      <el-table-column label="spot类型" align="center" prop="spotType" />
      <el-table-column label="状态" align="center" prop="status">
        <template #default="scope">
          <el-switch
            v-model="scope.row.status"
            :active-value="1"
            :inactive-value="0"
            @change="handleStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="更新时间" align="center" prop="updateTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.updateTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button
            link
            type="primary"
            icon="Edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            link
            type="primary"
            icon="Delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改数据类型对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="datatypeRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="名称" prop="title">
          <el-input v-model="form.title" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="描述" prop="description">
          <el-input v-model="form.description" placeholder="请输入描述" />
        </el-form-item>
        <el-form-item label="spot类型" prop="spotType">
          <el-input v-model="form.spotType" placeholder="请输入spot类型" />
        </el-form-item>
        <el-form-item label="组件" prop="component">
          <el-input v-model="form.component" placeholder="请输入组件" />
        </el-form-item>
        <el-form-item label="参数" prop="parameters" v-if="currentParams && currentParams.length > 0" >
          <el-form :model="choose" label-width="120px" label-position="left">
            <el-form-item v-for="(parameters, index) in currentParams" :key="index" :label="parameters.parameter">
              <el-select
                v-model="choose[parameters.parameter]"
                placeholder="请选择"
                size="large"
              >
                <el-option
                  v-for="item in parameters.params"
                  :key="item.param"
                  :label="item.param"
                  :value="item.param"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-form>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Datatype">
import {
  listDatatype,
  getDatatype,
  delDatatype,
  addDatatype,
  updateDatatype,
  updateDatatypeStatus
} from "@/api/VRdemo/datatype";

const { proxy } = getCurrentInstance();

const datatypeList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
// const paramsDict = ref([]);
const currentParams = ref([]);
const choose = ref([]); // 保存用户选择的数据

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    title: null,
    spotType: null,
    status: null
  },
  rules: {
    title: [{ required: true, message: "名称不能为空", trigger: "blur" }],
    component: [{ required: true, message: "组件不能为空", trigger: "blur" }],
    spotType: [
      {
        required: true,
        pattern: /^\d{1,2}$/,
        message: "请输入正确的spot类型",
        trigger: "blur"
      }
    ]
    // parameters: [{ required: true, message: "参数不能为空", trigger: "blur" }]
  }
});

// 查询状态选择
const options = [
  {
    value: "1",
    label: "启用"
  },
  {
    value: "0",
    label: "禁用"
  }
];

const { queryParams, form, rules } = toRefs(data);

/** 查询数据类型列表 */
function getList() {
  loading.value = true;
  listDatatype(queryParams.value).then(response => {
    datatypeList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    dataTypeId: null,
    title: null,
    description: null,
    component: null,
    spotType: null,
    parameters: null,
    status: null
  };
  choose.value = {};
  currentParams.value = {};
  proxy.resetForm("datatypeRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.dataTypeId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加数据类型";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _dataTypeId = row.dataTypeId || ids.value;
  getDatatype(_dataTypeId).then(response => {
    form.value = response.dataType;
    currentParams.value = response.parameters;
    open.value = true;
    title.value = "修改数据类型";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["datatypeRef"].validate(valid => {
    if (valid) {
      if (form.value.dataTypeId != null) {
        updateDatatype({ dataType: form.value, choose: choose.value }).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addDatatype({dataType: form.value}).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _dataTypeIds = row.dataTypeId || ids.value;
  proxy.$modal
    .confirm('是否确认删除数据类型编号为"' + _dataTypeIds + '"的数据项？')
    .then(function() {
      return delDatatype(_dataTypeIds);
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}

/** 数据类型状态修改 */
function handleStatusChange(row) {
  let text = row.status === 1 ? "启用" : "停用";
  proxy.$modal
    .confirm('确认要"' + text + '""' + row.title + '"数据类型吗?')
    .then(function() {
      return updateDatatypeStatus(row.dataTypeId, row.status);
    })
    .then(() => {
      proxy.$modal.msgSuccess(text + "成功");
    })
    .catch(function() {
      row.status = row.status === 0 ? 1 : 0;
    });
}

// /** 获取数据类型参数列表 */
// function getParmeterList() {
//   selectParameters().then(response => {
//     paramsDict.value = response.paramsDict;
//   });
// }

getList();
// getParmeterList();
</script>

